#!/usr/bin/awk -f
# Pre-process multi-line strings in a C program
# into a series of strings, one per line.
# Ex: asm("bla\n  bla") -> asm("bla"\n"  bla")

BEGIN {
  instring=0;
}

{
  # 1 unpaired \" on a line, or 3 \"s, or 5 \"s, or...
  if(match($0, "^[^\"]*\"[^\"]*$") || 
     match($0, "^[^\"]*\"[^\"]*\"[^\"]*\"[^\"]*$") ||
     match($0, "^[^\"]*\"[^\"]*\"[^\"]*\"[^\"]*\"[^\"]*\"[^\"]*$")) { 
    if(!instring) {
      instring=1;
      print $0"\"";
    } else {
      instring=0;
      print "\""$0;
    }
  } else if(instring)
    print "\""$0"\"";
  else print $0
}
